/* perform add, subtract, multiply and divide on complex numbers
B.R.Glasberg, Dept Exptl. Psychol., Cambridge.
*/
#include <stdio.h>
#include <math.h>
#include "recwide4.h"
#include "proto.h"

/* complex defined in recwide4.h 
typedef struct {
	float re,im;
	} complex;                 
*/
/*-----------------------------------------------------------*/
void cmplxmult(complex *a,complex *b,complex *c) /* complex multiply c = a*b */
{
float SumRe,SumIm;
SumRe = ((*a).re * (*b).re) - ((*a).im * (*b).im);
SumIm = ((*a).re * (*b).im) + ((*a).im * (*b).re);
(*c).re = SumRe;
(*c).im = SumIm;
}
/*--------------------------------------------------------------*/
int cmplxdiv(complex *a,complex *b,complex *c) /* complex divide c = a/b */
{
complex Num;
float Denom;
int div_succs;
Denom  = ((*b).re * (*b).re) + ((*b).im * (*b).im);
Num.re = ((*a).re * (*b).re) + ((*a).im * (*b).im);
Num.im = ((*a).im * (*b).re) - ((*a).re * (*b).im);
if(Denom != 0.0) {
	(*c).re = Num.re/Denom;
	(*c).im = Num.im/Denom;
	div_succs = 1;
}
else {
	(*c).re = 0.0;
	(*c).im = 0.0;
	div_succs = 0;
}
return(div_succs); /* return whether divide happened or not */
}
/*--------------------------------------------------------------*/
void cmplxadd(complex *a,complex *b,complex *c) /* complex addition c = a + b */
{
float SumRe,SumIm;
SumRe = ((*a).re + (*b).re);
SumIm = ((*a).im + (*b).im);
(*c).re = SumRe;
(*c).im = SumIm;
}
/*--------------------------------------------------------------*/
void cmplxsubt(complex *a,complex *b,complex *c) /* complex subtraction c = a - b */
{
float SumRe,SumIm;
SumRe = ((*a).re - (*b).re);
SumIm = ((*a).im - (*b).im);
(*c).re = SumRe;
(*c).im = SumIm;
}
/*---------------------------------------------------------------*/
void cmplxmag(complex *a,complex *b) /* complex magnitude b = |a| */
{
float SumRe, SumIm;
SumRe = ((*a).re * (*a).re) + ((*a).im * (*a).im);;
SumRe = sqrt(SumRe);
if((*a).re != 0.0) SumIm = (*a).im / (*a).re;
else SumIm = 0.0;
(*b).re = SumRe;
(*b).im = SumIm; /* puts tan(theta) in .im */
}
/*--------------------------------------------------------------*/
void cmplxmove(complex *a,complex *b) /*move contents of a to b */
{
(*b).re = (*a).re;
(*b).im = (*a).im;
}
