/* crecruit.h   header file */

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

#include "nrutil.h"

#define maxfft  16
#define maxfftpts  (1 << 13)   /* 2 ** 13 = 8192 */
#define nchans  13
#define npts  6000     /* .375 sec @ 16k. same ratio as 3 secs/65536 pt fft */
#define npfft  maxfftpts
#define offset  ((maxfftpts - npts)/2) /* (8192 - 6000)/2 = 1096 */
#define pi  3.1415926536
#define sqrt10  3.16227766
#define dB_rms_const  102.0
#define rms_const  23169.77
#define eq_loud_const 100.0

#define FALSE 0
#define TRUE  1

#define SHORTS sizeof(short)
/*
* 23169.8 = 32767/sqrt(2)
* with 10 in the chamber attenuator, a sinusiod with amplitude 1 has rms = 1/sqrt(2)
* with amplitude 32767, rms = 32767/sqrt(2) = 23169.77
*/


void args_in(int, char**, char*, char*, char*, float*, float*, float*, short*, float*);
void info(char**);
void int_to_real(float*, float*, short*, float);
void realft(float*, long, int);
void four1(float*, long, int);
void hil_ph(float*);
void outbits(float*, float*, float*, float*, float*, short, float*, short, float);
getopt(int argc, char *argv[], char *optionS);
