/*
	FORMULAE.C Functions from : Glasberg & Moore paper, (ie new) versions
		are from the 1990 G&M paper.

	Revised  by M.A.Stone Exp Psych. 1990.
Calculates the centre frequencies and ERB (equivalent rectangular bandwidth
of 'normal' auditory filters.
*/

#include <math.h>
#include <stdio.h>
#include "recwide4.h"
#include "proto.h"

/* new ERB formulae coefficients (G&M 1990) */
static float k1 = 24.7, k2 = 4.37e-3 ; /*frequency in Hz */

/*-------------------------------------------------------------------------*/
float Erb( float f ) /* calculate the erb at frequency f (new M&G formula) */
{
return ( k1*( k2*f + 1. ) );
}
/*---------------------------------------------------------------------*/
float ErbScale( float f ) /* calculate the E number at frequency f (new M&G) */
{	return( (float)(log( k2*f + 1. ) / (k1 * k2)) ); } /* tidy up dirty/ambiguous C */
/*------------------------------------------------------------------------*/
float FofErbScale( float E ) /* take E number and convert to frequency */
{	return ( (float)( exp( E * k1 * k2 ) - 1. ) / k2 ) ; }

/* ----------------  end of formulae.c  -------------------- */
