/*  -----------------------  rwbiquad.c  ---------------------------*/
/* read/write file with IIR filter parameters for band-pass filters */
/*file usually called RWBIQUAD.TST in recruitment simulation */
#include "recwide4.h"
#include "proto.h"

long rd_biquad_file(bq_file, coeffs, n)
FILE *bq_file;
struct Biquad *coeffs;
long n;
{
long channel,scrap;
float tmp1,tmp2;
char sntnc[50];

  for(channel = 0; channel < n; channel++){ /* 8 variables per structure */
		if(fscanf(bq_file, "%s %ld", sntnc, &scrap) == EOF) break; /* string and channel no. */
    if(fscanf(bq_file, "%f,%f", &tmp1, &tmp2) == EOF) break;
      coeffs->k0num = tmp1;
      coeffs->k1num = tmp2;
    if(fscanf(bq_file, "%f,%f", &tmp1, &tmp2) == EOF) break;
      coeffs->k1denom= tmp1;
      coeffs->k2denom= tmp2;
    if(fscanf(bq_file, "%f", &tmp1) == EOF) break;
      coeffs->E_no = tmp1;
    if(fscanf(bq_file, "%f,%f", &tmp1, &tmp2) == EOF) break;
      coeffs->a1 = tmp1;
      coeffs->b1 = tmp2;
    if(fscanf(bq_file,"%3d", &(coeffs->delay)) == EOF) break;
    coeffs++;
  }
return(channel);
}
/*---------------------------------------------------------------*/
long wr_biquad_file(bq_file, coeffs, n)
FILE *bq_file;
struct Biquad *coeffs;
long n;
{
long channel;

  for(channel = 0; channel < n; channel++){ /* 8 variables per structure */
    if(fprintf(bq_file,"............Channel_no. %2d\n",channel) == EOF) break;
    if(fprintf(bq_file,"%10.7f,%10.7f\n", coeffs->k0num, coeffs->k1num) == EOF)
	break;
    if(fprintf(bq_file, "%10.7f,%10.7f\n", coeffs->k1denom,coeffs->k2denom) == EOF)
	break;
    if(fprintf(bq_file, "%9.4f\n", coeffs->E_no) == EOF) break;
    if(fprintf(bq_file, "%10.7f,%10.7f\n", coeffs->a1, coeffs->b1) == EOF)
	break;
    if(fprintf(bq_file,"%3d\n", coeffs->delay ) == EOF) break;
    coeffs++;
  }
return(channel);
}
/* ----------------  end of rwbiquad.c  -------------------- */
